{ |========================================================================|
  |                                                                        |
  |                  Projet : découverte de BGRABITMAP                     |
  |                  Description : Programme exemple 05 bis ANTIALIASING   |
  |                  Unité : main.pas                                      |
  |                  Site : www.developpez.com                             |
  |                  Copyright : © Gilles VASSEUR 2017                     |
  |                                                                        |
  |                  Date:    26/02/2017 19:34:10                          |
  |                  Version : 1.0.0                                       |
  |                                                                        |
  |========================================================================| }

unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, StdCtrls, BGRABitmapTypes, BGRABitmap;

type

  { TMainForm }

  TMainForm = class(TForm)
    lblWidth: TLabel;
    lblPos: TLabel;
    lblLCL: TLabel;
    lblBGRABitmap: TLabel;
    pbLCL: TPaintBox;
    pbBGRA: TPaintBox;
    tbPos: TTrackBar;
    tbWidth: TTrackBar;
    procedure pbLCLPaint(Sender: TObject);
    procedure pbBGRAPaint(Sender: TObject);
    procedure tbPosChange(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }

procedure TMainForm.pbLCLPaint(Sender: TObject);
begin
  pbLCL.Canvas.Brush.Color := clWhite;
  pbLCL.Canvas.Pen.Width := tbWidth.Position;
  pbLCL.Canvas.FillRect(pbLCL.ClientRect);
  pbLCL.Canvas.MoveTo(20,20);
  pbLCL.Canvas.LineTo(tbPos.Position, 145);
end;

procedure TMainForm.pbBGRAPaint(Sender: TObject);
var
  Lbmp: TBGRABitmap;
begin
  Lbmp := TBGRABitmap.Create(pbBGRA.Width, pbBGRA.Height, BGRAWhite);
  try
    Lbmp.CanvasBGRA.Pen.Width := tbWidth.Position;
    Lbmp.CanvasBGRA.MoveTo(20, 20);
    Lbmp.CanvasBGRA.LineTo(tbPos.Position, 145);
    lbmp.Draw(pbBGRA.Canvas, 0, 0);
  finally
    Lbmp.Free;
  end;
end;

procedure TMainForm.tbPosChange(Sender: TObject);
begin
  Invalidate;
end;

end.

